#include "mainNode/MainNode.h"

#include <pluginlib/class_list_macros.h>

PLUGINLIB_EXPORT_CLASS(car::MainNode, nodelet::Nodelet);

namespace car
{
MainNode::MainNode(ros::NodeHandle & nh, std::string & name) :
    nh(nh)  
    , name(name)
    // OLD needs to be removed after test! , c2cNet()
    // OLD needs to be removed after test! , c2c()
    , c2c()
    , pcNet()
    , pc(pc2car::CommandReceiver::create(pcNet))
    , egoMotion(nh)
    , platoonController(c2c, pc, egoMotion)
    , platoonControllerThread([this] { platoonController.run(); })
    , cruiseController(egoMotion, platoonController)
    , cruiseControllerThread([this] { cruiseController.run(); })
{
  egoMotion.cruiseControllerNotify = cruiseControllerNotify;
  egoMotion.platoonControllerNotify = platoonControllerNotify;
  platoonController.cruiseControllerNotify = cruiseControllerNotify;
  // pc->reciveCommands([this] (auto commandCode) {platoonControllerThread.notify();} )
}

MainNode::MainNode() : 
    nh()  
    , name()
    // OLD needs to be removed after test! , c2cNet()
    // OLD needs to be removed after test! , c2c()
    , c2c()
    , pcNet()
    , pc(pc2car::CommandReceiver::create(pcNet))
    , egoMotion(nh)
    , platoonController(c2c, pc, egoMotion)
    , platoonControllerThread([this] { platoonController.run(); })
    , cruiseController(egoMotion, platoonController)
    , cruiseControllerThread([this] { cruiseController.run(); })
{
  egoMotion.cruiseControllerNotify = cruiseControllerNotify;
  egoMotion.platoonControllerNotify = platoonControllerNotify;
  platoonController.cruiseControllerNotify = cruiseControllerNotify;
  // pc->reciveCommands([this] (auto commandCode) {platoonControllerThread.notify();} )
}

MainNode::~MainNode()
{}

void MainNode::onInit()
{
    NODELET_INFO("MainNode::onInit -- START");
    NODELET_INFO("MainNode::onInit -- END");
}

}
